
static const char *RcsId = "$Id:  $";
//+=============================================================================
//
// file :         Interferometer.cpp
//
// description :  C++ source for the Interferometer and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                Interferometer are implemented in this file.
//
// project :      TANGO Device Server 
//
// $Author:  $
//
// $Revision:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source:  $
// $Log:  $
//
// copyleft :    Synchrotron SOLEIL 
//               L'Orme des merisiers - Saint Aubin
//               BP48 - 91192 Gif sur Yvette
//               FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name|  Method name
//	----------------------------------------
//  State   |  dev_state()
//  Status  |  dev_status()
//  Reset   |  reset()
//  Start   |  start()
//  Stop    |  stop()
//
//===================================================================
#include <yat/Portability.h>
#include <tango.h>
#include <Interferometer.h>
#include <InterferometerClass.h>
#include <E1735AAPI.h>
#include "PogoHelper.h"
#include <yat/utils/XString.h>
const double Pi = 3.141592654;
//const int OP_AIRTEMP = 1;

namespace Interferometer_ns
{

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::Interferometer(string &s)
// 
// description : 	constructor for simulated Interferometer
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
Interferometer::Interferometer(Tango::DeviceClass *cl,string &s)
	:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

Interferometer::Interferometer(Tango::DeviceClass *cl,const char *s)
	:Tango::Device_4Impl(cl,s)
{
	init_device();
}

Interferometer::Interferometer(Tango::DeviceClass *cl,const char *s,const char *d)
	:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void Interferometer::delete_device()
{
	// First close DLL
	Finalize_E1735A_DLL();
	//	Delete device allocated objects
	DELETE_SCALAR_ATTRIBUTE(attr_integrationTime_read);
	DELETE_SCALAR_ATTRIBUTE(attr_frequency_read);
    DELETE_SCALAR_ATTRIBUTE(attr_standardDeviation_read);
    DELETE_SCALAR_ATTRIBUTE(attr_angleConv_read);
	DELETE_SCALAR_ATTRIBUTE(attr_average_read);
	DELETE_SCALAR_ATTRIBUTE(attr_beamStrength_read);
	DELETE_SCALAR_ATTRIBUTE(attr_samplesQuantity_read);
	DELETE_SPECTRUM_ATTRIBUTE(attr_samples_read);

	initialize_hw_done = false;

}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void Interferometer::init_device()
{
	INFO_STREAM << "Interferometer::Interferometer() create device " << device_name << endl;

	CREATE_SCALAR_ATTRIBUTE(attr_integrationTime_read		,0.0);
    CREATE_SCALAR_ATTRIBUTE(attr_standardDeviation_read		,0.0);
    CREATE_SCALAR_ATTRIBUTE(attr_angleConv_read		,0.0);
	CREATE_SCALAR_ATTRIBUTE(attr_frequency_read		,0.0);
	CREATE_SCALAR_ATTRIBUTE(attr_average_read		,0.0);
	CREATE_SCALAR_ATTRIBUTE(attr_beamStrength_read		,0.0);
	CREATE_SCALAR_ATTRIBUTE(attr_samplesQuantity_read		,0.0);
	CREATE_SPECTRUM_ATTRIBUTE(attr_samples_read		,MAX_LENGTH, 0.0);
    //initialize varibles
    this->_distAngleConv = 0;

    airTemperature = -1;
    airPressure = -1;
    relativeHumidity = -1;
    scaleFactor = -1;

    get_device_property();

	initialize_hw_done = false;
    this->_negValues = false;
    this->_distAngleConv = distAngleConv;

	total_number_of_samples_read_in_buffer=0;

	//--------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		LeemAccessModule::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void Interferometer::get_device_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("DistAngleConv"));
	dev_prop.push_back(Tango::DbDatum("AirTemperature"));
	dev_prop.push_back(Tango::DbDatum("AirPressure"));
	dev_prop.push_back(Tango::DbDatum("RelativeHumidity"));
	dev_prop.push_back(Tango::DbDatum("ScaleFactor"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	InterferometerClass	*ds_class =
		(static_cast<InterferometerClass *>(get_device_class()));
	int	i = -1;

	//	Try to initialize DistAngleConv from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  distAngleConv;
	else {
		//	Try to initialize DistAngleConv from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  distAngleConv;
	}
	//	And try to extract DistAngleConv value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  distAngleConv;

	//	Try to initialize AirTemperature from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  airTemperature;
	else {
		//	Try to initialize AirTemperature from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  airTemperature;
	}
	//	And try to extract AirTemperature value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  airTemperature;

	//	Try to initialize AirPressure from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  airPressure;
	else {
		//	Try to initialize AirPressure from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  airPressure;
	}
	//	And try to extract AirPressure value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  airPressure;

	//	Try to initialize RelativeHumidity from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  relativeHumidity;
	else {
		//	Try to initialize RelativeHumidity from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  relativeHumidity;
	}
	//	And try to extract RelativeHumidity value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  relativeHumidity;

	//	Try to initialize ScaleFactor from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  scaleFactor;
	else {
		//	Try to initialize ScaleFactor from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  scaleFactor;
	}
	//	And try to extract ScaleFactor value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  scaleFactor;



	//	End of Automatic code generation
	//------------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void Interferometer::always_executed_hook()
{
	if (initialize_hw_done == false)
	{
		initialize_hw_done = InitilializeDll();
	}
	else
		// refresh HW state 
		dev_state();

}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void Interferometer::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "Interferometer::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_standardDeviation
// 
// description : 	Extract real attribute values for standardDeviation acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_standardDeviation(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_standardDeviation(Tango::Attribute &attr) entering... "<< endl;
    attr.set_value(attr_standardDeviation_read);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_negValues
// 
// description : 	Extract real attribute values for negValues acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_negValues(Tango::Attribute &attr)
{
    DEBUG_STREAM << "Interferometer::read_negValues(Tango::Attribute &attr) entering... "<< endl;
    attr.set_value(&this->_negValues);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::write_negValues
// 
// description : 	Write negValues attribute values to hardware.
//
//-----------------------------------------------------------------------------
void Interferometer::write_negValues(Tango::WAttribute &attr)
{
    DEBUG_STREAM << "Interferometer::write_negValues(Tango::WAttribute &attr) entering... "<< endl;
    attr.get_write_value(this->_negValues);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_samplesQuantity
// 
// description : 	Extract real attribute values for samplesQuantity acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_samplesQuantity(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_samplesQuantity(Tango::Attribute &attr) entering... "<< endl;
	*attr_samplesQuantity_read = attr_integrationTime_write/attr_frequency_write;
	attr.set_value(attr_samplesQuantity_read);
}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_angleConv
// 
// description : 	Extract real attribute values for angleConv acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_angleConv(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_angleConv(Tango::Attribute &attr) entering... "<< endl;
    attr.set_value(attr_angleConv_read);
}
//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_BeamStrength
// 
// description : 	Extract real attribute values for BeamStrength acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_beamStrength(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_BeamStrength(Tango::Attribute &attr) entering... "<< endl;

	attr.set_value(&_beamStrength);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_integrationTime
// 
// description : 	Extract real attribute values for integrationTime acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_integrationTime(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_integrationTime(Tango::Attribute &attr) entering... "<< endl;
	attr.set_value(&attr_integrationTime_write);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::write_integrationTime
// 
// description : 	Write integrationTime attribute values to hardware.
//
//-----------------------------------------------------------------------------
void Interferometer::write_integrationTime(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Interferometer::write_integrationTime(Tango::WAttribute &attr) entering... "<< endl;

	// Check if integrationTime is compatible with acquisition spectrum length
	double new_integrationTime;
	attr.get_write_value(new_integrationTime);

	int	count = static_cast<int> ( new_integrationTime/attr_frequency_write);

	if (new_integrationTime <=0 || count > MAX_LENGTH)
	{
		string error ="IntegrationTime must be >0 or IntegrationTime/Frequency =< " + yat::XString<int>::to_string(MAX_LENGTH)	;
		Tango::Except::throw_exception ((const char *)"BAD_PARAMETER",
			(const char *)error.c_str(),
			(const char *)"Interferometer::write_integrationTime()");
	}

	// Check State 

	Tango::DevState st = this->get_state();
	if ((st == Tango::RUNNING))

	{
		Tango::Except::throw_exception ((const char *)"BAD_STATE",
			(const char *)"Action not allowed in this state - Device must be <STANDBY>",
			(const char *)"Spectrometer::write_integrationTime");
	}
	else
	{
		//Ecriture
		attr_integrationTime_write=new_integrationTime;
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_frequency
// 
// description : 	Extract real attribute values for frequency acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_frequency(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_frequency(Tango::Attribute &attr) entering... "<< endl;
	attr.set_value(&attr_frequency_write);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::write_frequency
// 
// description : 	Write frequency attribute values to hardware.
//
//-----------------------------------------------------------------------------
void Interferometer::write_frequency(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Interferometer::write_frequency(Tango::WAttribute &attr) entering... "<< endl;

	// Check if frequency is compatible with acquisition spectrum length
	double new_frequency;
	attr.get_write_value(new_frequency);

	int	count = static_cast<int> ( attr_integrationTime_write/new_frequency);

	if (new_frequency <=0 || count > MAX_LENGTH)
	{
		string error ="Frequency must be >0 or IntegrationTime/Frequency =< " + yat::XString<int>::to_string(MAX_LENGTH);
		Tango::Except::throw_exception ((const char *)"BAD_PARAMETER",
			(const char *)error.c_str(),
			(const char *)"Interferometer::write_frequency()");
	}

	//GestionState	    
	Tango::DevState st = this->get_state();
	if ((st == Tango::RUNNING))

	{
		Tango::Except::throw_exception ((const char *)"BAD_STATE",
			(const char *)"Action not allowed in this state - Device must be <STANDBY>",
			(const char *)"Spectrometer::write_SamplingDuration");
	}
	else
	{
		//We can store the new value 
		attr_frequency_write=new_frequency;
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_samplesNumber
// 
// description : 	Extract real attribute values for samplesNumber acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_average(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_samplesNumber(Tango::Attribute &attr) entering... "<< endl;

    int signe = -1;

    if (this->_negValues && *attr_average_read < 0)
        *attr_average_read = *attr_average_read * signe;
    
	attr.set_value(attr_average_read);
}

//+----------------------------------------------------------------------------
//
// method : 		Interferometer::read_samples
//
// description : 	Extract real attribute values for samples acquisition result.
//
//-----------------------------------------------------------------------------
void Interferometer::read_samples(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Interferometer::read_samples(Tango::Attribute &attr) entering... "<< endl;
	int count;
	count = static_cast<int> ( attr_integrationTime_write/attr_frequency_write);

	//Copy in Tango attribute only count values 
	attr.set_value(attr_samples_read, count);			
}

//+------------------------------------------------------------------
/**
 *	method:	Interferometer::reset
 *
 *	description:	method to execute "Reset"
 *	Use to reset the device.
 *
 *
 */
//+------------------------------------------------------------------
void Interferometer::reset()
{
	DEBUG_STREAM << "Interferometer::reset(): entering... !" << endl;

	//	Add your own code to control device here
	bool result;	
	// First close DLL
	Finalize_E1735A_DLL();
	result = InitilializeDll();

	if (result == true) 
	{
		result = E1735A_ResetDevice();
		set_state(Tango::STANDBY);
		set_status("Device is Reset");
	}
	else 
	{
		set_state(Tango::FAULT);
		set_status("Device was not Reset");
		string last_error = get_error_string(E1735A_ReadLastError());
		Tango::Except::throw_exception ((const char *)"Failed to reset the device",
			(const char *)last_error.c_str(),
			(const char *)"Interferometre::reset()");
	}

}

//+------------------------------------------------------------------
/**
 *	method:	Interferometer::start
 *
 *	description:	method to execute "Start"
 *	Use to start the device.
 *
 *
 */
//+------------------------------------------------------------------
void Interferometer::start()
{
	DEBUG_STREAM << "Interferometer::start(): entering... !" << endl;

	//	Add your own code to control device here

	total_number_of_samples_read_in_buffer=0;
	*attr_average_read=0;

    double tempFromProperties = E1735A_GetParameter(OP_AIRTEMP);
    double airPressureFromProperties = E1735A_GetParameter(OP_AIRPRES);
    double relativeHumidityFromProperties = E1735A_GetParameter(OP_RELHUMI);
    double scaleFactorFromProperties = E1735A_GetParameter(OP_SCALEFACTOR);
    
    std::cout<<"temp from properties : "<<tempFromProperties<<std::endl; 
    std::cout<<"air from properties : "<<airPressureFromProperties<<std::endl; 
    std::cout<<"humidity from properties : "<<relativeHumidityFromProperties<<std::endl; 
    std::cout<<"scale factor from properties : "<<scaleFactorFromProperties<<std::endl; 

	bool result;

	//FLUSH SPECTRUM
	for (int i = 0; i <MAX_LENGTH; i++)
	{
		attr_samples_read[i]=yat::IEEE_NAN;
	}
	// SETUP TIMER
	result = E1735A_SetupTimer(attr_frequency_write);

	if (result==true)
	{
		result = false;

		// flush hardware buffers
		E1735A_ReadAllSamples(NULL,MAX_LENGTH);
		// start acquisition 
		result = E1735A_StartTimer();

		//STATE
		if (result==true)
		{
			set_state(Tango::RUNNING);
			set_status("Timer is started successfully");
		}
		else
		{
			set_state(Tango::FAULT);
			set_status("Not Running");
			string last_error = get_error_string(E1735A_ReadLastError());
			Tango::Except::throw_exception ((const char *)"Timer is not started",
				(const char *)last_error.c_str(),
				(const char *)"Interferometre::start()");
		}
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Interferometer::stop
 *
 *	description:	method to execute "Stop"
 *	Use to strop the device.
 *
 *
 */
//+------------------------------------------------------------------
void Interferometer::stop()
{
	DEBUG_STREAM << "Interferometer::stop(): entering... !" << endl;

	//	Add your own code to control device here
	bool result=false;
	//GestionErreur/State
	result = E1735A_StopTimer();
	if (result==true) 
	{
		set_state(Tango::STANDBY);
		set_status("Timer is stopped successfully");
	}
	else
	{
		set_state(Tango::FAULT);
		set_status("Timer was not stopped successfully");
		string last_error = get_error_string(E1735A_ReadLastError());
		Tango::Except::throw_exception ((const char *)"Failed to stop timer",
			(const char *)last_error.c_str(),
			(const char *)"Interferometre::stop()");
	}
}

//+------------------------------------------------------------------
/**
//  INTERNAL METHODS NOT GENERATED BY POGO 
*/
//+------------------------------------------------------------------
/**
*	method:	Interferometer::InitilializeDll
*
*	description:	method to deal with DLL initialisation
*/
//+------------------------------------------------------------------
bool Interferometer::InitilializeDll()
{

	bool result1=false, result2=false;	
	if (Initialize_E1735A_DLL() == 0)
	{
		// read the number of connected devices & select the first one
		if ((E1735A_ReadDeviceCount() > 0) && E1735A_SelectDevice(0))  
		{
			result1 = E1735A_ResetDevice();
			E1735A_SetupAQB(0,0,0);
			result2 = E1735A_SetSampleTriggers(TB_TIMER);
			set_status("E1735A is Found");
            //to set environnement variable on inteferometer
            if (airTemperature <40 && airTemperature>0) 
            setEnvironnementParameter(OP_AIRTEMP, airTemperature);
            if (airPressure <110 && airPressure>70)
            setEnvironnementParameter(OP_AIRPRES, airPressure);
            if (relativeHumidity <100 && relativeHumidity>0)
            setEnvironnementParameter(OP_RELHUMI, relativeHumidity);
            if (scaleFactor <397 && scaleFactor>0.01)
            setEnvironnementParameter(OP_SCALEFACTOR , scaleFactor);

			if (result1 == true)
			{
				if (result2 == true)
				{
					set_status("Timer is Initialized");
					set_state(Tango::STANDBY);
				}
				else
				{
					set_status("Timer is not Initialized");
					set_state(Tango::FAULT);
				}	
			}
			else
			{
				set_status("Device was not Reset");
				set_state(Tango::FAULT);
			}
		}
		else
		{
			set_status("E1735A not Found");
			set_state(Tango::FAULT);
		}
	}
	else
	{
		set_status("Failed to initialize E1735A.dll");
		set_state(Tango::FAULT);
	}

	if (result1==true && result2==true)
	{
		return true;
	}	
	else
	{
		return false;
	}
}
//+------------------------------------------------------------------
/**
*	method:	Interferometer::get_error_string
*
*	description:	get error messages from DLL
*/
//+------------------------------------------------------------------


string Interferometer::get_error_string(int lastError)
{
	string error;
	int lastEr = lastError;
	// SWITCH-CASE selection erreur
	switch(lastEr)
	{
	case 0 : error = "No error from board";
		break;
	case 1 : error = "Unknown exception";
		break;
	case 2 : error = "Failed to access registers of E1735A";
		break;
	case 3 : error = "Parameter out of range";
		break;
	case 11 : error = "Read empty buffer";
		break;
	case 12 : error = "Hardware/software buffer full";
		break;
	case 13 : error = "Samples are copied to NULL pointer";
		break;
	case 14 : error = "Timer is still on";
		break;
	case 15 : error = "For TimerSamples";
		break;
	case 16 : error = "For TimerSamples";
		break;
	case 17 : error = "For TimerSamples";
		break;
	case 18 : error = "For ReadSampleAndAQB";
		break;
	case 21 : error = "No ref. signal";
		break;
	case 22 : error = "No mea. signal";
		break;
	case 23 : error = "Reg. signal was lost";
		break;
	case 24 : error = "Mea. signal was lost";
		break;
	case 25 : error = "Glitch error found in reg. signal";
		break;
	case 26 : error = "Glitch error found in mea. signal";
		break;
	case 27 : error = "Lost of external trig or others under timer";
		break;
	case 28 : error = "Mea. position too large";
		break;
	default : error = "Unknown error";
		return error;
	}
}

//+------------------------------------------------------------------
/**
*	method:	Interferometer::dev_state
*
*	description:	method to execute "State"
*	This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
*
* @return	State Code
*
*/
//+------------------------------------------------------------------
Tango::DevState Interferometer::dev_state()
{
	Tango::DevState	argout = DeviceImpl::dev_state();
	DEBUG_STREAM << "Interferometer::dev_state(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	// always check if laser operates correctly
	check_laser_state();
	// Is acquisition started check also acquisition status
	if ((st == Tango::RUNNING))
	{
		// check the state of the acquisition
		check_acquisition_state();
	}

	return argout;
}


//+------------------------------------------------------------------
//+------------------------------------------------------------------

void  Interferometer::check_acquisition_state()
{
	int count;
	int error_laser;
	count = static_cast<int> ( attr_integrationTime_write/attr_frequency_write);
	DEBUG_STREAM << "Interferometer::read_samples count=" << count << endl;
	// 
	int number_of_samples_in_buffer = E1735A_ReadAllSamples(readTLaserSamples,MAX_LENGTH );	
    int signe = -1;
	// Copy data in internal array  attribute
	for (int i = 0; i <number_of_samples_in_buffer; i++)
	{
		set_status("Reading data from interferometer"); 
        if (this->_negValues && readTLaserSamples[i].LaserPos < 0)
		attr_samples_read[total_number_of_samples_read_in_buffer+i] = readTLaserSamples[i].LaserPos * signe;
        else
        attr_samples_read[total_number_of_samples_read_in_buffer+i] = readTLaserSamples[i].LaserPos;

		error_laser = readTLaserSamples[i].LaserError;

		if (error_laser!= 0)
		{
			set_state(Tango::FAULT);
			set_status("Laser error");
			string last_error = get_error_string(error_laser);
			Tango::Except::throw_exception ((const char *)"Laser error",
				(const char *)last_error.c_str(),
				(const char *)"check_acquisition_state()");
		}
	}
	// 
	total_number_of_samples_read_in_buffer = total_number_of_samples_read_in_buffer + number_of_samples_in_buffer;

	// check if acquisition is finished
	// Be careful : we may have acquired more data than "count" number because electronics is acquiring continously
	if ( total_number_of_samples_read_in_buffer >= count )
	{
		stop(); 
		// calculate average
		for (int i = 0; i <count; i++)
		{
			*attr_average_read=*attr_average_read + attr_samples_read[i];
        }
		if (count !=0)
        {
			*attr_average_read = *attr_average_read/count;
             // Calculate Standard Deviation
            *attr_standardDeviation_read = cal_et(attr_samples_read, count, *attr_average_read);
            // if there is a dist, convert to angle
            if (this->_distAngleConv != 0)
                *attr_angleConv_read = (asin(*attr_average_read / this->_distAngleConv)) / Pi * 180;
            else 
                *attr_angleConv_read = yat::IEEE_NAN;
        }
	}
}
//+------------------------------------------------------------------
//+------------------------------------------------------------------
double Interferometer::cal_et(double tab[], int nbr, double moy)
{
   double total=0, ecart, variance;

   for(int i=0; i < nbr; i++)
       { ecart = tab[i]-moy;
         total = total + ecart*ecart;
       } 
   
   variance = total / (nbr -1);
   
   return (sqrt(variance));
}
//+------------------------------------------------------------------
//+------------------------------------------------------------------
void  Interferometer::check_laser_state()
{
	// to check if laser works, we need to get its beamstrength
	_beamStrength=E1735A_ReadBeamStrength();
	_beamStrength=_beamStrength*100;

	Tango::DevState st = this->get_state();

	if (st != Tango::FAULT)
	{	
		if(_beamStrength==0)
		{	
			set_state(Tango::FAULT);
			set_status("Signal Lost");				
			string last_error = get_error_string(E1735A_ReadLastError());
			Tango::Except::throw_exception ((const char *)"signal lost",
				(const char *)last_error.c_str(),
				(const char *)"read_beamStrength()");

			// Data is not available
			_beamStrength=yat::IEEE_NAN;

		}
	}
}
// ============================================================================
// Interferometer::setEnvironnementParameter
// ============================================================================
void Interferometer::setEnvironnementParameter(int index, double value)
{	
    Tango::DevState st = this->get_state();

	if (st != Tango::FAULT)
	{	
		bool response = E1735A_SetParameter(index, value);
        if (!response)
        {
        set_state(Tango::FAULT);
		set_status("Device is not initialize, Failed to set environnement variable on device");
        string last_error = get_error_string(E1735A_ReadLastError());
        Tango::Except::throw_exception ((const char *)"Failed to set environnement variable on device",
			(const char *)last_error.c_str(),
			(const char *)"Interferometre::setEnvironnementParameter(int index, double value)");
        }
        
    }   
}
}	//	namespace
